# Development and testing

## Get Strapper running

### Create a development environment

The following command will create a virtual environment, load dependencies
defined in `requirements.txt` files, and retrieve submodules.  Note that it's
a good idea to specify the Python version to get the latest available on your
platform, though this is optional.

    $ PYTHON=python3.12 make dev-setup
    ... [ a whole bunch of package stuff ] ...
    venv created; to activate use '. venv/bin/activate'
    $

<!-- ### Creating a configuration file

The configuration file for the running app is
expected in the `strapper/instance/` sub-directory.

    $ mkdir strapper/instance
    $ touch strapper/instance/strapper.conf

In `strapper/instance/strapper.conf`, a basic configuration would suffice:

    [database]

    [deployment]
    terraform = tbd
    chart = tbd -->

<!-- ### Retrieving static resources

Not applicable in the template.  Static resources are those which do not
change, or at least do not as part of this project, and can be accessed from
an external website, so that when this application is packaged as a container,
it is not necessary to include these resources.  In addition, they don't need
to be stored with the rest of the project source.

Examples:
- external JavaScript libraries
- icon libraries
- third-party images -->

### Start up the application
Create a `strapper/strapper/.env.prod` file. The file should include:
```
# For configuration
SECRET_KEY='Django secret key'
DEBUG=True
ALLOWED_HOSTS='List of allowed hosts'
AUTHX_USER_OVERRIDE=admin@example.org

# For Postgre
POSTGRES_DB=postgres
POSTGRES_NAME=postgres
POSTGRES_USER=postgres
POSTGRES_PASSWORD=password
POSTGRES_HOST=db
# POSTGRES_HOST=localhost
POSTGRES_PORT=5432

# Enable storing state files in a remote storage (S3 bucket)
TERRAFORM_BACKEND_ENABLED=False

# For S3 bucket hosted by MinIO (ONLY need this if setting TERRAFORM_BACKEND_ENABLED=True)
AWS_ENDPOINT_URL_S3='S3 bucket URL'
AWS_REGION='S3 bucket region'
AWS_ACCESS_KEY_ID='S3 access key id'
AWS_SECRET_ACCESS_KEY='S3 secret access key'

# For Kubernetes
KUBE_SERVER='K8s server url'
KUBE_CLIENT_CERTIFICATE='K8s client certificate'
KUBE_KEY='K8s key'

KUBE_CONFIG_DIR='Kube directory that stores on config file. e.g. "~/.kube"'

# For Terraform
TERRAFORM_DOMAIN='Domain for your apps e.g. "example.com"'

# TERRAFORM_DB_HOST='https://db.rcs.uvic.ca'
TERRAFORM_DB_HOST='Database server URL'
TERRAFORM_DB_NAME='Database name'
TERRAFORM_DB_USERNAME='Database username'
TERRAFORM_DB_PASSWORD='Database password for the username above'

TERRAFORM_KEYCLOAK_CLIENT_ID='Keycloak client ID'
TERRAFORM_KEYCLOAK_CLIENT_SECRET='Keycloak client secret'
TERRAFORM_KEYCLOAK_URL='Keycloak URL'
TERRAFORM_KEYCLOAK_BASE_PATH='Keycloak base path'
```

Create another environment variable file `strapper/strapper/.env.db`:

    POSTGRES_DB=strapper
    POSTGRES_NAME=postgres
    POSTGRES_USER=postgres
    POSTGRES_PASSWORD=password

Create a config file at `strapper/instance/strapper.conf`. The following settings would suffice:

    [database]

    [deployment]
    terraform = /usr/bin/terraform
    chart = /usr/bin/helm

Build and start up the necessary containers for the app:

    $ docker build -f deployments/Dockerfile -t strapper_web:latest .   # Build the app image
    $ docker-compose -f deployments/docker-compose.prod.yml up -d   # Stand app image up with a Postgre and Selenium container
    $ docker-compose -f deployments/docker-compose.prod.yml exec web python3 manage.py migrate  # Migrate database schema

If you want to run the app on a development server, make sure to change
`POSTGRES_HOST=localhost` in the `.env` file. Run:

    $ python3 strapper/manage.py runserver 0.0.0.0:8000  # Using 8000 in case your container is running on 8001
    Watching for file changes with StatReloader
    Performing system checks...

    System check identified no issues (0 silenced).
    September 08, 2022 - 10:01:46
    Django version 4.1.1, using settings 'strapper.settings'
    Starting development server at http://0.0.0.0:8000/
    Quit the server with CTRL-BREAK.

## Versioning

Application versioning is based on Git tags.  Release versions follow the
format `x.y.z` (ex. "2.0.1") where the `.z` is optional.  A "v" prefix is
optional but discouraged by Python packaging standards.  Release versions are
implemented as annotated tags on the main branch.

Development tags follow the format `x.y.z.devN` (ex. "2.0.2.dev3") where
`x.y.z` represent the _targeted upcoming release_, not the last release, and
`N` represents an arbitrary sequence.  Developers may use these tags on
branches other than main and these must not be annotated tags, as otherwise
the tag and its annotation will show up in the changelog.

The version is represented in the source code and made available to the
application via the auto-generated file `strapper/version.py`.  This file is
generated by the `make` target "update_version" and can be refreshed with
`make update_version`.
